package schedframe.resources.computing.profiles.energy.power;

import java.util.Map;
import java.util.TreeMap;

public class PState {

	protected String name;
	protected double frequency;
	protected double voltage;
	protected double powerUsage;
	protected double powerUsageMin;
	protected double powerUsageMax;
	//protected List<LoadPowerUsage> loadPowerUsageList;
	protected Map<Double, Double> loadPowerUsage;
	
	/*public PState(PStateType name, double frequency, double voltage, double power) {
		super();
		this.name = name;
		this.frequency = frequency;
		this.voltage = voltage;
		this.power = power;
	}*/
	
	public String getName() {
		return name;
	}
	public double getFrequency() {
		return frequency;
	}
	public double getVoltage() {
		return voltage;
	}
	public double getPower() {
		if(powerUsage == 0)
			powerUsage = (powerUsageMin + powerUsageMax)/2;
		return powerUsage;
	}
	public double getPowerMin() {
		return powerUsageMin;
	}
	public double getPowerMax() {
		return powerUsageMax;
	}
	/*public List<LoadPowerUsage> getLoadPowerUsageList() {
		return loadPowerUsageList;
	}*/
	public Map<Double, Double> getLoadPowerUsage() {
		if(loadPowerUsage == null) {
			return new TreeMap<Double, Double>();
		}
		return loadPowerUsage;
	}

	public static class Builder {
	  
		protected String name;
		protected double frequency;
		protected double voltage;
		protected double powerUsage;
		protected double powerUsageMin;
		protected double powerUsageMax;
		//protected List<LoadPowerUsage> loadPowerUsageList = new ArrayList<LoadPowerUsage>();
		protected Map<Double, Double> loadPowerUsage = new TreeMap<Double, Double>();
		
		public Builder name(String name){this.name = name; return this; }
        public Builder frequency(double value){this.frequency = value; return this; }
        public Builder voltage(double value){this.voltage = value; return this; }
        public Builder powerUsage(double rate){this.powerUsage = rate; return this; }
        public Builder powerUsageMin(double rate){this.powerUsageMin = rate; return this; }
        public Builder powerUsageMax(double rate){this.powerUsageMax = rate; return this; }
        //public Builder loadPowerUsage(LoadPowerUsage lpu){this.loadPowerUsageList.add(lpu); return this; }
        public Builder loadPowerUsage(double load, double power){this.loadPowerUsage.put(load, power); return this; }
        
        public PState build() {
            return new PState(this);
        }
	}
	
	private PState(Builder builder) {
		this.name = builder.name;
		this.frequency = builder.frequency;
		this.voltage = builder.voltage;
		this.powerUsage = builder.powerUsage;
		this.powerUsageMin = builder.powerUsageMin;
		this.powerUsageMax = builder.powerUsageMax;
		//this.loadPowerUsageList = builder.loadPowerUsageList;
		this.loadPowerUsage = builder.loadPowerUsage;
	}


}
